package com.example.infrared;

import android.app.Activity;
import android.app.ProgressDialog;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.text.TextUtils;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.EditText;
import android.widget.RadioButton;
import android.widget.ScrollView;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;


import com.rscja.deviceapi.FingerprintWithFIPS;
import com.rscja.deviceapi.Infrared;
import com.rscja.deviceapi.exception.ConfigurationException;

import com.rscja.utility.StringUtility;

import java.util.Arrays;

public class MainActivity extends Activity {
    Button btnSend_ifr;
    Button btnClear;
    EditText etData;
    CheckBox cbContinuous;
    EditText etBetween;
    TextView tvReceive;
    ScrollView svResult;
    CheckBox cbIDPower;
    CheckBox cbHex;
    RadioButton rb97;
    RadioButton rb07;
    TextView tv_succ_count;
    TextView tv_fail_count;
    TextView tv_elapsed_time;
    Spinner spCheck;

    private Button btnInit;
    private CheckBox cbLED;
    private Button btnFree;
    private boolean isOpen = false;
    private boolean isIDPower = false;
    private boolean is97 = true;
    private boolean isHex = true;
    AutoSendThread autoThread = null;
    ReceiveThread mReceiveThread = null;
    private Infrared mInfrared;


    int sussCount = 0;
    int failCount = 0;

    private long lastClickTime;

    private Handler mHandler = new Handler() {
        @Override
        public void handleMessage(Message msg) {
            super.handleMessage(msg);
            if (msg != null) {
                String strData = msg.obj.toString();
                if (isIDPower) {
                    if (msg.what == 2) {
                       // tvReceive.append(strData + "\n");//zp add
                        if (strData.indexOf(":") > 0) {
                            String[] arr = strData.split(":");
                            if (arr != null && arr.length > 1) {
                                tvReceive.append(getString(R.string.title_power_id)+":"+arr[0]+" "+getString(R.string.title_id_power)+":"+arr[1] + "\n");
                            }
                            else {
                                tvReceive.append(strData + "\n");
                            }
                        }
                        else {
                            tvReceive.append(strData + "\n");
                        }
                    }
                } else {
                    tvReceive.append(strData + "\n");
                }
                scrollToBottom(svResult, tvReceive);
                stat();
            }
        }
    };

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        init();
        cbLED.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                if(isChecked){
                    mInfrared.openLED();
                }else{
                    mInfrared.closeLED();
                }
            }
        });
        cbHex.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                isHex = isChecked;
            }
        });

        rb97.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                if (rb97.isChecked()) {
                    is97 = true;
                    etData.setText("68AAAAAAAAAAAA68010243C3D516");
                }
            }
        });

        rb07.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                if (rb07.isChecked()) {
                    is97 = false;
                    etData.setText("68AAAAAAAAAAAA68110433333333AD16");
                }
            }
        });

        cbIDPower.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                isIDPower = isChecked;
            }
        });

        btnInit.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                final int check = spCheck.getSelectedItemPosition();
                new initTask(check).execute();
            }
        });

        btnFree.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                free();
            }
        });
        btnClear.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                reset();
            }
        });
       btnSend_ifr.setOnClickListener(new View.OnClickListener() {
           @Override
           public void onClick(View view) {
               send();
           }
       });
    }
    @Override
    protected void onResume() {
        super.onResume();
    }
    @Override
    protected void onPause() {
        super.onPause();
    }


    @Override
    protected void onDestroy() {
        super.onDestroy();
        mInfrared.closeLED();
        free();
    }



    private void reset() {
        sussCount = 0;
        failCount = 0;
        tv_succ_count.setText(String.valueOf(sussCount));
        tv_fail_count.setText(String.valueOf(failCount));
        tvReceive.setText("");
        tv_elapsed_time.setText("");
    }

    private void stat() {
        tv_succ_count.setText(String.valueOf(sussCount));
        tv_fail_count.setText(String.valueOf(failCount));
        long time = System.currentTimeMillis();
        long timeD = time - lastClickTime;
        tv_elapsed_time.setText(timeD + " ms");
    }

    private void init(){
        btnInit = (Button) findViewById(R.id.btnInit_uart);
        btnFree = (Button) findViewById(R.id.btnFree_uart);
        cbLED=(CheckBox)findViewById(R.id.cbLED);
        btnSend_ifr=(Button)findViewById(R.id.btnSend_ifr);
        btnClear=(Button)findViewById(R.id.btnClear);
        etData=(EditText)findViewById(R.id.etData);
        cbContinuous=(CheckBox)findViewById(R.id.cbContinuous);
        etBetween=(EditText) findViewById(R.id.et_between);
        tvReceive=(TextView)findViewById(R.id.tvReceive);
        svResult=(ScrollView)findViewById(R.id.svResult);
        cbIDPower=(CheckBox)findViewById(R.id.cbIDPower);
        cbHex=(CheckBox)findViewById(R.id.cbHex);
        rb97=(RadioButton)findViewById(R.id.rb97);
        rb07=(RadioButton)findViewById(R.id.rb07);
        tv_succ_count=(TextView)findViewById(R.id.tv_succ_count);
        tv_fail_count=(TextView)findViewById(R.id.tv_fail_count);
        tv_elapsed_time=(TextView)findViewById(R.id.tv_elapsed_time);
        spCheck=(Spinner)findViewById(R.id.spCheck);
        try {
            mInfrared = Infrared.getInstance();
        } catch (ConfigurationException e) {
            e.printStackTrace();
        }
    }

    public class initTask extends AsyncTask<String, Integer, Boolean> {
        int check=0;
        public initTask(int check){
              this.check=check;
        }
        ProgressDialog mypDialog;

        @Override
        protected Boolean doInBackground(String... params) {
            // TODO Auto-generated method stub
            boolean result = false;
            if (mInfrared != null) {
                result = mInfrared.open(1200, check);
            }
            return result;
        }

        @Override
        protected void onPostExecute(Boolean result) {
            super.onPostExecute(result);

            if (result && !isIDPower) {
                mReceiveThread = new ReceiveThread();
                mReceiveThread.start();
            }
            isOpen = result;
            setBtnEnable(isOpen);
            mypDialog.cancel();
        }

        @Override
        protected void onPreExecute() {
            // TODO Auto-generated method stub
            super.onPreExecute();
            mypDialog = new ProgressDialog(MainActivity.this);
            mypDialog.setProgressStyle(ProgressDialog.STYLE_SPINNER);
            mypDialog.setMessage("init...");
            mypDialog.setCanceledOnTouchOutside(false);
            mypDialog.show();
        }

    }
    protected void free() {
        if (isOpen) {
            if (mInfrared.close()) {
                isOpen = false;
                if (autoThread != null) {
                    autoThread.stopThread();
                    autoThread = null;
                }
                if (mReceiveThread != null) {
                    mReceiveThread.stopThread();
                    mReceiveThread = null;
                }
            }
        }
        setBtnEnable(isOpen);
    }

    private void setBtnEnable(boolean enable) {
        btnFree.setEnabled(enable);
        btnSend_ifr.setEnabled(enable);
        btnInit.setEnabled(!enable);

        spCheck.setEnabled(!enable);
        cbIDPower.setEnabled(!enable);
        rb97.setEnabled(!enable);
        rb07.setEnabled(!enable);
    }


    protected void send() {

        String content = etData.getText().toString();
        if (TextUtils.isEmpty(content)) {
            return;
        }
        if (cbHex.isChecked()) {
            if (!StringUtility.isHexNumberRex(content)) {
               Toast.makeText(this,"请输入十六进制数",Toast.LENGTH_SHORT).show();
              return;
            }
        }
        if (mInfrared == null) {
            return;
        }
        if (btnSend_ifr.getText().toString().equals(getString(R.string.send))) {
            int sleep = toInt(etBetween.getText().toString(), 0);
            boolean auto = cbContinuous.isChecked();
            autoThread = new AutoSendThread(auto, content, sleep * 1000);
            autoThread.start();
            if (auto) {
                btnSend_ifr.setText(R.string.btStop);
                btnFree.setEnabled(false);
            }
        } else {
            if (autoThread != null) {
                autoThread.stopThread();
                autoThread = null;
            }
            btnSend_ifr.setText(R.string.send);
            btnFree.setEnabled(true);
        }
    }


    class AutoSendThread extends Thread {
        String mContent;
        int mSleep = 0;
        boolean mAuto = false;
        Message msg;
        String idPower;
        int tryCount=0;

        public AutoSendThread(boolean auto, String content, int sleep) {
            mContent = content;
            mSleep = sleep;
            mAuto = auto;
        }

        @Override
        public void run() {
            super.run();
            byte[] sendBytes = null;
            do {

                lastClickTime = System.currentTimeMillis();
                //---------------获取电能值--------------------------------------
                if (isIDPower) {
                    while (tryCount<2)
                    {
                        if (is97) {
                            idPower = mInfrared.getIDAndPowerWithWattmeter();
                        } else {
                            idPower = mInfrared.getIDAndPowerWithWattmeter(07);
                        }

                        if (!TextUtils.isEmpty(idPower))
                        {
                            break;
                        }
                        tryCount++;
                    }
                    tryCount=0;

                    msg = new Message();
                    msg.what = 2;
                    if (TextUtils.isEmpty(idPower)) {
                        msg.obj = "fail";
                        failCount++;
                    } else {
                        msg.obj = idPower;
                        sussCount++;
                    }
                    mHandler.sendMessage(msg);
                    //---------------获取电能值--------------------------------------
                } else {

                    if (isHex) {
                        sendBytes = StringUtility.hexString2Bytes(mContent);
                    } else {
                        sendBytes = mContent.getBytes();
                    }
                    mInfrared.send(sendBytes);
                }
                try {
                    sleep(mSleep);
                } catch (InterruptedException e) {

                }
            } while (!isInterrupted() && mAuto);
        }

        public void stopThread() {
            mAuto = false;
            Thread.currentThread().interrupt();
        }

    }


    class ReceiveThread extends Thread {
        byte[] data;
        Message msg;
        boolean threadStop = false;

        public ReceiveThread() {
            threadStop = false;
        }
        @Override
        public void run() {
            do {
                data = mInfrared.receive();
                if (data == null || data.length == 0) {
                    continue;
                } else {
                    msg = new Message();
                    msg.arg1 = 1;
                    sussCount++;
                    if (isHex) {
                        msg.obj = StringUtility.bytes2HexString(data, data.length);
                    } else {
                        msg.obj = new String(data);
                    }
                    mHandler.sendMessage(msg);
                }
            } while (!threadStop && !isInterrupted());
        }

        public void stopThread() {
            threadStop = true;
            Thread.currentThread().interrupt();
        }
        public boolean isStop() {
            return threadStop;
        }
    }
    /**
     * 将ScrollView根据内部控件高度定位到底端
     *
     * @param scroll
     * @param inner
     */
    public void scrollToBottom(final View scroll, final View inner) {
        Handler mHandler = new Handler();
        mHandler.post(new Runnable() {
            public void run() {
                if (scroll == null || inner == null) {
                    return;
                }
                int offset = inner.getMeasuredHeight() - scroll.getHeight();
                if (offset < 0) {
                    offset = 0;
                }
                scroll.scrollTo(0, offset);
            }
        });
    }
    /**
     * 字符串转整数
     *
     * @param str
     * @param defValue
     * @return
     */
    public static int toInt(String str, int defValue) {
        try {
            return Integer.parseInt(str);
        } catch (Exception e) {
        }
        return defValue;
    }}
